#!/usr/bin/env python2
# -*- coding: UTF-8 -*-

import logging
import os
import subprocess


class Launcher(object):
    """ Класс для запуска приложений пользователем autologon """
    def __init__(self, app):
        self.args = ['sudo', '-u', 'autologon']
        self.app = app

    def run(self, args, autologon=True):
        """ Запуск приложения с параметрами
        Args:
            args(list of str) - список параметров
            autologon(bool) - флаг использования пользователя autologon при вызове приложения
        Returns:
            subprocess.Popen - хэндлер запущенного процесса
        """
        args = (self.args if autologon else []) + [self.app] + args
        logging.info(u"Запуск %s: '%s'" % (self.app, " ".join(args)))
        os.environ["DISPLAY"] = ":255"
        os.environ["XAUTHORITY"] = "/home/autologon/.Xauthority"
        p = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        logging.debug(u"PID процесса - %s" % str(p.pid))
        return p
